﻿using MVCSampleBrowser.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index() {
            
            return View();
        }
        public ActionResult Data(string gridObj)
        {
            var obj = new NorthwindDataContext().EmployeeViews.ToList();
            return Json(obj, JsonRequestBehavior.AllowGet);
        }

        public ActionResult DataSource(DataManager dm)
        {
            var Data = OrderRepository.GetAllRecords().ToList();
            DataResult result = new DataResult();
            result.count = Data.Count();
            DataOperations operation = new DataOperations();
            IEnumerable res = operation.Execute(Data, dm);
            result.result = res;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}